SystemOrganization addCategory: #'CS528-UT3AI'!

TestCase subclass: #UT3AITest
	instanceVariableNames: 'gameBoard'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3AI'!

!UT3AITest commentStamp: '<historical>' prior: 0!
An UT3AITest is the test package for UT3AI which is a package for the Ultimate tic-tac-toe chess AI decision making

Instance Variables
	gameBoard:		<Object>

gameBoard
	- xxxxx
!

!UT3AITest methodsFor: 'tests' stamp: 'Oliver 7/13/2013 17:09'!
test1
	| board1 system1 |
	system1 := UT3System new.
	board1 := system1 board. 
	self should: [UT3AI new initialize: board1] raise: AIError.! !

!UT3AITest methodsFor: 'tests' stamp: 'Oliver 7/16/2013 16:07'!
testAIFillsUpBoard
	|board ai|
	board := UT3BasicBoard new.
	ai := UT3RandomAI newWith: board as: #cross.
	1 to: ( board size * board size ) do: [ 
		:unused_each | ai move ].
	self assert: board isFull.! !

UT3AITest subclass: #UT3EasyAITest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3AI'!

!UT3EasyAITest methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/8/2013 18:05'!
test2AIsFillUpBoard
	|board ai1 ai2 totalMoves crossCount circleCount |
	board := UT3BasicBoard new.
	ai1 := UT3EasyAI newWith: board as: #cross.
	ai2 := UT3RandomAI newWith: board as: #circle.
	
	"Depending on board size, we might not have equal number of moves"
	totalMoves := ( board size * board size ).
	(totalMoves % 2 = 0)
	ifTrue: [ 
		1 to: ( totalMoves / 2 ) do: [ :unused_move | ai1 move. ai2 move. ] ]
	ifFalse: [ 
		ai1 move.
		1 to: ( totalMoves - 1 / 2 ) do: [ :unused_move | ai2 move. ai1 move. ] ].
	
	"When done, the board should be full."
	self assert: board isFull.
	Transcript show: board printBoardString.
	crossCount := 0.
	circleCount := 0.
	
	board indicesDo: [ :aRow :aCol |
		( (board at: aRow at: aCol) state = #cross )
		ifTrue: [ crossCount := crossCount + 1 ]
		ifFalse: [ circleCount := circleCount + 1 ] ].
	self assert: ( crossCount - circleCount <= 1 )
! !

!UT3EasyAITest methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/8/2013 18:05'!
testAIFillsUpBoard
	|board ai|
	board := UT3BasicBoard new.
	ai := UT3EasyAI newWith: board as: #cross.
	1 to: ( board size * board size ) do: [ 
		:unused_each | ai move ].
	self assert: board isFull.! !

!UT3EasyAITest methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/8/2013 18:05'!
testBasicWhenFullThrowsError
	|board ai|
	board := UT3BasicBoard new.
	ai := UT3RandomAI newWith: board as: #cross.
	1 to: ( board size * board size ) do: [ 
		:unused_each | ai move ].
	self assert: board isFull.
	self should: [ ai move ] raise: AIError! !

!UT3EasyAITest methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/11/2013 16:19'!
testUT3EasyAIvsUT3RandomAI
	|board ai1 ai2 crossCount circleCount i |
	board := UT3BasicBoard new.
	ai1 := UT3EasyAI newWith: board as: #cross.
	ai2 := UT3RandomAI newWith: board as: #circle.
	i := 0.
	crossCount := 0.
	circleCount := 0.
	"Depending on board size, we might not have equal number of moves"
	Transcript clear.
	[(crossCount + circleCount) < 150] whileTrue: [
	[(board winner = #undecided)] whileTrue: [
		(i % 2 = 0)
		ifTrue: [ ai1 move.]
		ifFalse: [ ai2 move].
		i := i + 1.
	].
		(board winner = #cross) ifTrue: [ crossCount := crossCount + 1 ].
		(board winner = #circle) ifTrue: [ circleCount := circleCount + 1 ].
		Transcript show: board printBoardString; cr.
		board resetWithSize: 3.
	].
	"When done, the board should be full."
	Transcript	show: board printBoardString; cr; 
			   	show: (crossCount asString); cr;
				show: (circleCount asString); cr;						
				show: (board winner); cr.! !

UT3AITest subclass: #UT3HardAITest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3AI'!

!UT3HardAITest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/16/2013 15:41'!
test1
	|board ai|
	" checks playing logic works, and a full board logic is right"
	board := UT3BasicBoard new.
	ai := UT3HardAI newWith: board as: #cross.
	board at: {#2.#2} put: (ai piece).
	board at: {#1.#2} put: (ai piece).
	board at: {#2.#1} put: (ai piece).
	board at: {#2.#3} put: (ai piece).
	board at: {#1.#1} put: (ai piece).
	board at: {#3.#2} put: (ai piece).
	board at: {#3.#3} put: (ai piece).
	board at: {#1.#3} put: (ai piece).
	board at: {#3.#1} put: (ai piece).
	self assert: board isFull.
! !

!UT3HardAITest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/16/2013 15:41'!
test2
	|board ai|
	" checks one move of playing logic, see if the AI works as expected."
	board := UT3BasicBoard new.
	ai := UT3HardAI newWith: board as: #cross.
	board at: {#1.#2} put: (#circle).
	ai move.
	self assert: ((board at: 2 at: 2) state) = (ai piece).
! !

!UT3HardAITest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/16/2013 15:41'!
test2AIsFillUpBoard
	|board ai1 ai2 totalMoves crossCount circleCount |
	board := UT3BasicBoard new.
	ai1 := UT3HardAI newWith: board as: #cross.
	ai2 := UT3RandomAI newWith: board as: #circle.
	
	"Depending on board size, we might not have equal number of moves"
	totalMoves := ( board size * board size ).
	(totalMoves % 2 = 0)
	ifTrue: [ 
		1 to: ( totalMoves / 2 ) do: [ :unused_move | ai1 move. ai2 move. ] ]
	ifFalse: [ 
		ai1 move.
		1 to: ( totalMoves - 1 / 2 ) do: [ :unused_move | ai2 move. ai1 move. ] ].
	
	"When done, the board should be full."
	self assert: board isFull.
	Transcript show: board printBoardString.
	crossCount := 0.
	circleCount := 0.
	
	board indicesDo: [ :aRow :aCol |
		( (board at: aRow at: aCol) state = #cross )
		ifTrue: [ crossCount := crossCount + 1 ]
		ifFalse: [ circleCount := circleCount + 1 ] ].
	self assert: ( crossCount - circleCount <= 1 )
! !

!UT3HardAITest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/16/2013 15:41'!
test3
	|board ai|
	" checks three move of playing logic, see if the AI works as expected."
	board := UT3BasicBoard new.
	ai := UT3HardAI newWith: board as: #cross.
	board at: {#1.#2} put: (#circle).
	ai move.
	board at: {#2.#3} put: (#circle).
	ai move.
	board at: {#3.#2} put: (#circle).
	ai move.
	self assert: ((board at: 2 at: 2) state) = (ai piece).
! !

!UT3HardAITest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/19/2013 17:08'!
test4
	|board ai|
	" checks three move of playing logic, see if the AI works as expected."
	board := UT3BasicBoard new.
	ai := UT3HardAI newWith: board as: #cross.
	board at: {#2.#2} put: (#circle).
	ai move.

	self assert: ((board at: 1 at: 1) state) = (ai piece).
! !

!UT3HardAITest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/16/2013 16:05'!
testAIFillsUpBoard
	|board ai|
	board := UT3BasicBoard new.
	ai := UT3HardAI newWith: board as: #cross.
	1 to: ( board size * board size ) do: [ 
		:unused_each | ai move ].
	self assert: board isFull.! !

!UT3HardAITest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/16/2013 15:41'!
testBasicWhenFullThrowsError
	|board ai|
	board := UT3BasicBoard new.
	ai := UT3HardAI newWith: board as: #cross.
	1 to: ( board size * board size ) do: [ 
		:unused_each | ai move ].
	self assert: board isFull.
	self should: [ ai move ] raise: AIError! !

!UT3HardAITest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/19/2013 17:08'!
testUT3HardAIvsUT3EasyAI
	|board ai1 ai2 crossCount circleCount i |
	board := UT3BasicBoard new.
	ai1 := UT3HardAI newWith: board as: #cross.
	ai2 := UT3EasyAI newWith: board as: #circle.
	i := 0.
	crossCount := 0.
	circleCount := 0.
	"Depending on board size, we might not have equal number of moves"
	Transcript clear.
	[(crossCount + circleCount) < 150] whileTrue: [
	[(board winner = #undecided)] whileTrue: [
		(i % 2 = 0)
		ifTrue: [ ai1 move.]
		ifFalse: [ ai2 move].
		i := i + 1.
	].
		(board winner = #cross) ifTrue: [ crossCount := crossCount + 1 ].
		(board winner = #circle) ifTrue: [ circleCount := circleCount + 1 ].
		Transcript show: board printBoardString; cr.
		board resetWithSize: 3.
	].
	"When done, the board should be full."
	Transcript	show: board printBoardString; cr; 
			   	show: (crossCount asString); cr;
				show: (circleCount asString); cr;						
				show: (board winner); cr.! !

!UT3HardAITest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/19/2013 17:09'!
testUT3HardAIvsUT3MedAI
	|board ai1 ai2 crossCount circleCount i |
	board := UT3BasicBoard new.
	ai1 := UT3HardAI newWith: board as: #cross.
	ai2 := UT3MedAI newWith: board as: #circle.
	i := 0.
	crossCount := 0.
	circleCount := 0.
	"Depending on board size, we might not have equal number of moves"
	Transcript clear.
	[(crossCount + circleCount) < 150] whileTrue: [
	[(board winner = #undecided)] whileTrue: [
		(i % 2 = 0)
		ifTrue: [ ai1 move.]
		ifFalse: [ ai2 move].
		i := i + 1.
	].
		(board winner = #cross) ifTrue: [ crossCount := crossCount + 1 ].
		(board winner = #circle) ifTrue: [ circleCount := circleCount + 1 ].
		Transcript show: board printBoardString; cr.
		board resetWithSize: 3.
	].
	"When done, the board should be full."
	Transcript	show: board printBoardString; cr; 
			   	show: (crossCount asString); cr;
				show: (circleCount asString); cr;						
				show: (board winner); cr.! !

!UT3HardAITest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/16/2013 15:41'!
testUT3HardAIvsUT3RandomAI
	|board ai1 ai2 crossCount circleCount i |
	board := UT3BasicBoard new.
	ai1 := UT3HardAI newWith: board as: #cross.
	ai2 := UT3RandomAI newWith: board as: #circle.
	i := 0.
	crossCount := 0.
	circleCount := 0.
	"Depending on board size, we might not have equal number of moves"
	Transcript clear.
	[(crossCount + circleCount) < 150] whileTrue: [
	[(board winner = #undecided)] whileTrue: [
		(i % 2 = 0)
		ifTrue: [ ai1 move.]
		ifFalse: [ ai2 move].
		i := i + 1.
	].
		(board winner = #cross) ifTrue: [ crossCount := crossCount + 1 ].
		(board winner = #circle) ifTrue: [ circleCount := circleCount + 1 ].
		Transcript show: board printBoardString; cr.
		board resetWithSize: 3.
	].
	"When done, the board should be full."
	Transcript	show: board printBoardString; cr; 
			   	show: (crossCount asString); cr;
				show: (circleCount asString); cr;						
				show: (board winner); cr.! !

UT3AITest subclass: #UT3InsaneAITest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3AI'!

!UT3InsaneAITest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/20/2013 14:04'!
test1
	|board ai|
	" checks playing logic works, and a full board logic is right"
	board := UT3BasicBoard new.
	ai := UT3InsaneAI newWith: board as: #cross.
	board at: {#2.#2} put: (ai piece).
	board at: {#1.#2} put: (ai piece).
	board at: {#2.#1} put: (ai piece).
	board at: {#2.#3} put: (ai piece).
	board at: {#1.#1} put: (ai piece).
	board at: {#3.#2} put: (ai piece).
	board at: {#3.#3} put: (ai piece).
	board at: {#1.#3} put: (ai piece).
	board at: {#3.#1} put: (ai piece).
	self assert: board isFull.
! !

!UT3InsaneAITest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/20/2013 14:04'!
test2
	|board ai|
	" checks one move of playing logic, see if the AI works as expected."
	board := UT3BasicBoard new.
	ai := UT3InsaneAI newWith: board as: #cross.
	board at: {#1.#2} put: (#circle).
	ai move.
	self assert: ((board at: 2 at: 2) state) = (ai piece).
! !

!UT3InsaneAITest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/20/2013 14:05'!
test2AIsFillUpBoard
	|board ai1 ai2 totalMoves crossCount circleCount |
	board := UT3BasicBoard new.
	ai1 := UT3InsaneAI newWith: board as: #cross.
	ai2 := UT3RandomAI newWith: board as: #circle.
	
	"Depending on board size, we might not have equal number of moves"
	totalMoves := ( board size * board size ).
	(totalMoves % 2 = 0)
	ifTrue: [ 
		1 to: ( totalMoves / 2 ) do: [ :unused_move | ai1 move. ai2 move. ] ]
	ifFalse: [ 
		ai1 move.
		1 to: ( totalMoves - 1 / 2 ) do: [ :unused_move | ai2 move. ai1 move. ] ].
	
	"When done, the board should be full."
	self assert: board isFull.
	Transcript show: board printBoardString.
	crossCount := 0.
	circleCount := 0.
	
	board indicesDo: [ :aRow :aCol |
		( (board at: aRow at: aCol) state = #cross )
		ifTrue: [ crossCount := crossCount + 1 ]
		ifFalse: [ circleCount := circleCount + 1 ] ].
	self assert: ( crossCount - circleCount <= 1 )
! !

!UT3InsaneAITest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/20/2013 14:05'!
test3
	|board ai|
	" checks three move of playing logic, see if the AI works as expected."
	board := UT3BasicBoard new.
	ai := UT3InsaneAI newWith: board as: #cross.
	board at: {#1.#2} put: (#circle).
	ai move.
	board at: {#2.#3} put: (#circle).
	ai move.
	board at: {#3.#2} put: (#circle).
	ai move.
	self assert: ((board at: 2 at: 2) state) = (ai piece).
! !

!UT3InsaneAITest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/20/2013 14:05'!
test4
	|board ai|
	" checks three move of playing logic, see if the AI works as expected."
	board := UT3BasicBoard new.
	ai := UT3InsaneAI newWith: board as: #cross.
	board at: {#2.#2} put: (#circle).
	ai move.

	self assert: ((board at: 1 at: 1) state) = (ai piece).
! !

!UT3InsaneAITest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/20/2013 14:05'!
testAIFillsUpBoard
	|board ai|
	board := UT3BasicBoard new.
	ai := UT3InsaneAI newWith: board as: #cross.
	1 to: ( board size * board size ) do: [ 
		:unused_each | ai move ].
	self assert: board isFull.! !

!UT3InsaneAITest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/20/2013 14:05'!
testBasicWhenFullThrowsError
	|board ai|
	board := UT3BasicBoard new.
	ai := UT3InsaneAI newWith: board as: #cross.
	1 to: ( board size * board size ) do: [ 
		:unused_each | ai move ].
	self assert: board isFull.
	self should: [ ai move ] raise: AIError! !

!UT3InsaneAITest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/20/2013 14:05'!
testUT3InsaneAIvsUT3EasyAI
	|board ai1 ai2 crossCount circleCount i |
	board := UT3BasicBoard new.
	ai1 := UT3InsaneAI newWith: board as: #cross.
	ai2 := UT3EasyAI newWith: board as: #circle.
	i := 0.
	crossCount := 0.
	circleCount := 0.
	"Depending on board size, we might not have equal number of moves"
	Transcript clear.
	[(crossCount + circleCount) < 150] whileTrue: [
	[(board winner = #undecided)] whileTrue: [
		(i % 2 = 0)
		ifTrue: [ ai1 move.]
		ifFalse: [ ai2 move].
		i := i + 1.
	].
		(board winner = #cross) ifTrue: [ crossCount := crossCount + 1 ].
		(board winner = #circle) ifTrue: [ circleCount := circleCount + 1 ].
		Transcript show: board printBoardString; cr.
		board resetWithSize: 3.
	].
	"When done, the board should be full."
	Transcript	show: board printBoardString; cr; 
			   	show: (crossCount asString); cr;
				show: (circleCount asString); cr;						
				show: (board winner); cr.! !

!UT3InsaneAITest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/20/2013 14:05'!
testUT3InsaneAIvsUT3MedAI
	|board ai1 ai2 crossCount circleCount i |
	board := UT3BasicBoard new.
	ai1 := UT3InsaneAI newWith: board as: #cross.
	ai2 := UT3MedAI newWith: board as: #circle.
	i := 0.
	crossCount := 0.
	circleCount := 0.
	"Depending on board size, we might not have equal number of moves"
	Transcript clear.
	[(crossCount + circleCount) < 150] whileTrue: [
	[(board winner = #undecided)] whileTrue: [
		(i % 2 = 0)
		ifTrue: [ ai1 move.]
		ifFalse: [ ai2 move].
		i := i + 1.
	].
		(board winner = #cross) ifTrue: [ crossCount := crossCount + 1 ].
		(board winner = #circle) ifTrue: [ circleCount := circleCount + 1 ].
		Transcript show: board printBoardString; cr.
		board resetWithSize: 3.
	].
	"When done, the board should be full."
	Transcript	show: board printBoardString; cr; 
			   	show: (crossCount asString); cr;
				show: (circleCount asString); cr;						
				show: (board winner); cr.! !

!UT3InsaneAITest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/20/2013 14:05'!
testUT3InsaneAIvsUT3RandomAI
	|board ai1 ai2 crossCount circleCount i |
	board := UT3BasicBoard new.
	ai1 := UT3InsaneAI newWith: board as: #cross.
	ai2 := UT3RandomAI newWith: board as: #circle.
	i := 0.
	crossCount := 0.
	circleCount := 0.
	"Depending on board size, we might not have equal number of moves"
	Transcript clear.
	[(crossCount + circleCount) < 150] whileTrue: [
	[(board winner = #undecided)] whileTrue: [
		(i % 2 = 0)
		ifTrue: [ ai1 move.]
		ifFalse: [ ai2 move].
		i := i + 1.
	].
		(board winner = #cross) ifTrue: [ crossCount := crossCount + 1 ].
		(board winner = #circle) ifTrue: [ circleCount := circleCount + 1 ].
		Transcript show: board printBoardString; cr.
		board resetWithSize: 3.
	].
	"When done, the board should be full."
	Transcript	show: board printBoardString; cr; 
			   	show: (crossCount asString); cr;
				show: (circleCount asString); cr;						
				show: (board winner); cr.! !

UT3AITest subclass: #UT3MedAITest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3AI'!

!UT3MedAITest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/14/2013 06:02'!
test1
	|board ai|
	" checks playing logic works, and a full board logic is right"
	board := UT3BasicBoard new.
	ai := UT3MedAI newWith: board as: #cross.
	board at: {#2.#2} put: (ai piece).
	board at: {#1.#2} put: (ai piece).
	board at: {#2.#1} put: (ai piece).
	board at: {#2.#3} put: (ai piece).
	board at: {#1.#1} put: (ai piece).
	board at: {#3.#2} put: (ai piece).
	board at: {#3.#3} put: (ai piece).
	board at: {#1.#3} put: (ai piece).
	board at: {#3.#1} put: (ai piece).
	self assert: board isFull.
! !

!UT3MedAITest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/14/2013 06:03'!
test2
	|board ai|
	" checks one move of playing logic, see if the AI works as expected."
	board := UT3BasicBoard new.
	ai := UT3MedAI newWith: board as: #cross.
	board at: {#1.#2} put: (#circle).
	ai move.
	self assert: ((board at: 2 at: 2) state) = (ai piece).
! !

!UT3MedAITest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/13/2013 17:48'!
test2AIsFillUpBoard
	|board ai1 ai2 totalMoves crossCount circleCount |
	board := UT3BasicBoard new.
	ai1 := UT3MedAI newWith: board as: #cross.
	ai2 := UT3RandomAI newWith: board as: #circle.
	
	"Depending on board size, we might not have equal number of moves"
	totalMoves := ( board size * board size ).
	(totalMoves % 2 = 0)
	ifTrue: [ 
		1 to: ( totalMoves / 2 ) do: [ :unused_move | ai1 move. ai2 move. ] ]
	ifFalse: [ 
		ai1 move.
		1 to: ( totalMoves - 1 / 2 ) do: [ :unused_move | ai2 move. ai1 move. ] ].
	
	"When done, the board should be full."
	self assert: board isFull.
	Transcript show: board printBoardString.
	crossCount := 0.
	circleCount := 0.
	
	board indicesDo: [ :aRow :aCol |
		( (board at: aRow at: aCol) state = #cross )
		ifTrue: [ crossCount := crossCount + 1 ]
		ifFalse: [ circleCount := circleCount + 1 ] ].
	self assert: ( crossCount - circleCount <= 1 )
! !

!UT3MedAITest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/14/2013 06:04'!
test3
	|board ai|
	" checks three move of playing logic, see if the AI works as expected."
	board := UT3BasicBoard new.
	ai := UT3MedAI newWith: board as: #cross.
	board at: {#1.#2} put: (#circle).
	ai move.
	board at: {#2.#3} put: (#circle).
	ai move.
	board at: {#3.#2} put: (#circle).
	ai move.
	self assert: ((board at: 2 at: 2) state) = (ai piece).
! !

!UT3MedAITest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/16/2013 16:05'!
testAIFillsUpBoard
	|board ai|
	board := UT3BasicBoard new.
	ai := UT3MedAI newWith: board as: #cross.
	1 to: ( board size * board size ) do: [ 
		:unused_each | ai move ].
	self assert: board isFull.! !

!UT3MedAITest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/13/2013 23:38'!
testBasicWhenFullThrowsError
	|board ai|
	board := UT3BasicBoard new.
	ai := UT3MedAI newWith: board as: #cross.
	1 to: ( board size * board size ) do: [ 
		:unused_each | ai move ].
	self assert: board isFull.
	self should: [ ai move ] raise: AIError! !

!UT3MedAITest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/16/2013 16:01'!
testUT3MedAIvsUT3EasyAI
	|board ai1 ai2 crossCount circleCount i |
	board := UT3BasicBoard new.
	ai1 := UT3MedAI newWith: board as: #cross.
	ai2 := UT3EasyAI newWith: board as: #circle.
	i := 0.
	crossCount := 0.
	circleCount := 0.
	"Depending on board size, we might not have equal number of moves"
	Transcript clear.
	[(crossCount + circleCount) < 150] whileTrue: [
	[(board winner = #undecided)] whileTrue: [
		(i % 2 = 0)
		ifTrue: [ ai1 move.]
		ifFalse: [ ai2 move].
		i := i + 1.
	].
		(board winner = #cross) ifTrue: [ crossCount := crossCount + 1 ].
		(board winner = #circle) ifTrue: [ circleCount := circleCount + 1 ].
		Transcript show: board printBoardString; cr.
		board resetWithSize: 3.
	].
	"When done, the board should be full."
	Transcript	show: board printBoardString; cr; 
			   	show: (crossCount asString); cr;
				show: (circleCount asString); cr;						
				show: (board winner); cr.! !

!UT3MedAITest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/13/2013 17:48'!
testUT3MedAIvsUT3RandomAI
	|board ai1 ai2 crossCount circleCount i |
	board := UT3BasicBoard new.
	ai1 := UT3MedAI newWith: board as: #cross.
	ai2 := UT3RandomAI newWith: board as: #circle.
	i := 0.
	crossCount := 0.
	circleCount := 0.
	"Depending on board size, we might not have equal number of moves"
	Transcript clear.
	[(crossCount + circleCount) < 150] whileTrue: [
	[(board winner = #undecided)] whileTrue: [
		(i % 2 = 0)
		ifTrue: [ ai1 move.]
		ifFalse: [ ai2 move].
		i := i + 1.
	].
		(board winner = #cross) ifTrue: [ crossCount := crossCount + 1 ].
		(board winner = #circle) ifTrue: [ circleCount := circleCount + 1 ].
		Transcript show: board printBoardString; cr.
		board resetWithSize: 3.
	].
	"When done, the board should be full."
	Transcript	show: board printBoardString; cr; 
			   	show: (crossCount asString); cr;
				show: (circleCount asString); cr;						
				show: (board winner); cr.! !

UT3AITest subclass: #UT3NestedRandomAITest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3AI'!

!UT3NestedRandomAITest methodsFor: 'as yet unclassified' stamp: 'ShineLow 7/8/2013 01:37'!
test2AIsFillUpBoard
	"Same test as the normal RandomAI, just keep playing till entire board is full."
	|board ai1 ai2 currentMove|
	board := UT3NestedBoard new.
	ai1 := UT3NestedRandomAI newWith: board as: #cross.
	ai2 := UT3NestedRandomAI newWith: board as: #circle.
	currentMove := 0.
	[ board isFull ] whileFalse: [ 
		(currentMove % 2 = 0)
		ifTrue: [ ai1 move ]
		ifFalse: [ ai2 move ].
		currentMove := currentMove + 1
		 ].
	Transcript show: board printBoardString.
	! !

UT3AITest subclass: #UT3RandomAITest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3AI'!

!UT3RandomAITest methodsFor: 'as yet unclassified' stamp: 'JonathanOsting 7/8/2013 14:12'!
test2AIsFillUpBoard
	|board ai1 ai2 totalMoves crossCount circleCount |
	board := UT3BasicBoard new.
	ai1 := UT3RandomAI newWith: board as: #cross.
	ai2 := UT3RandomAI newWith: board as: #circle.
	
	"Depending on board size, we might not have equal number of moves"
	totalMoves := ( board size * board size ).
	(totalMoves % 2 = 0)
	ifTrue: [ 
		1 to: ( totalMoves / 2 ) do: [ :unused_move | ai1 move. ai2 move. ] ]
	ifFalse: [ 
		ai1 move.
		1 to: ( totalMoves - 1 / 2 ) do: [ :unused_move | ai2 move. ai1 move. ] ].
	
	"When done, the board should be full."
	self assert: board isFull.
	Transcript show: board printBoardString.
	crossCount := 0.
	circleCount := 0.
	
	board indicesDo: [ :aRow :aCol |
		( (board at: aRow at: aCol) state = #cross )
		ifTrue: [ crossCount := crossCount + 1 ]
		ifFalse: [ circleCount := circleCount + 1 ] ].
	self assert: ( crossCount - circleCount <= 1 )
! !

!UT3RandomAITest methodsFor: 'as yet unclassified' stamp: 'ShineLow 7/8/2013 00:16'!
testAIFillsUpBoard
	|board ai|
	board := UT3BasicBoard new.
	ai := UT3RandomAI newWith: board as: #cross.
	1 to: ( board size * board size ) do: [ 
		:unused_each | ai move ].
	self assert: board isFull.! !

!UT3RandomAITest methodsFor: 'as yet unclassified' stamp: 'ShineLow 7/8/2013 00:39'!
testBasicWhenFullThrowsError
	|board ai|
	board := UT3BasicBoard new.
	ai := UT3RandomAI newWith: board as: #cross.
	1 to: ( board size * board size ) do: [ 
		:unused_each | ai move ].
	self assert: board isFull.
	self should: [ ai move ] raise: AIError! !

Error subclass: #AIError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3AI'!

!AIError commentStamp: '<historical>' prior: 0!
An AIError is error for when the AI encounters a problem.

Instance Variables
!

Object subclass: #UT3AI
	instanceVariableNames: 'board piece'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3AI'!

!UT3AI commentStamp: '<historical>' prior: 0!
An UT3AI is a package for the Ultimate tic-tac-toe chess AI decision making.

Instance Variables
	gameBoard:		<Object>

gameBoard
	- xxxxx
!

!UT3AI class methodsFor: 'as yet unclassified' stamp: 'ShineLow 7/8/2013 00:42'!
new
	AIError signal: 'Instantiate with newWith: aBoard as: aPiece'! !

!UT3AI class methodsFor: 'as yet unclassified' stamp: 'ShineLow 7/8/2013 01:33'!
newWith: aBoard as: aPiece
	^ self basicNew board: aBoard piece: aPiece! !

!UT3AI methodsFor: 'initialize-release' stamp: 'ShineLow 7/8/2013 00:44'!
board: aBoard piece: aPiece
	board := aBoard.
	piece := aPiece.! !

!UT3AI methodsFor: 'public' stamp: 'ShineLow 7/8/2013 00:41'!
move
	^ self subclassResponsibility ! !

!UT3AI methodsFor: 'initialize-release' stamp: 'Oliver 7/14/2013 00:04'!
piece

	^piece! !

UT3AI subclass: #UT3AISuper
	instanceVariableNames: 'privateMatrix privateSet retMatrix retMove aiThinkingTime corners weighting scoring'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3AI'!

!UT3AISuper commentStamp: '<historical>' prior: 0!
An UT3AISuper is xxxxxxxxx.

Instance Variables
	privateMatrix:		<Object>
	privateSet:		<Object>
	retMatrix:		<Object>
	retMove:		<Object>

privateMatrix
	- xxxxx

privateSet
	- xxxxx

retMatrix
	- xxxxx

retMove
	- xxxxx
!

!UT3AISuper methodsFor: 'Winning Judgements' stamp: 'Oliver 7/16/2013 15:55'!
checkWinningWithCol: subMatrix

	| ret1 ret2 ret3 |
	ret1 := (self checkWinningWithSet: ((subMatrix atColumn: 1) asSet)).
	ret2 := (self checkWinningWithSet: ((subMatrix atColumn: 2) asSet)).
	ret3 := (self checkWinningWithSet: ((subMatrix atColumn: 3) asSet)).
	ret1 > 0 
	ifTrue:[^ret1]
	ifFalse:[ret2> 0
		ifTrue:[^ret2]
		ifFalse:[ret3 > 0
			ifTrue:[^ret3]
			ifFalse:[^0]
			]
		]! !

!UT3AISuper methodsFor: 'Winning Judgements' stamp: 'Oliver 7/16/2013 15:55'!
checkWinningWithDiagonal: subMatrix

	| ret1 ret2  |
	ret1 := (self checkWinningWithSet: ((subMatrix diagonal) asSet)).
	ret2 := (self checkWinningWithSet: ( Set newFrom: { (subMatrix at: 1 at: 3). (subMatrix at: 2 at: 2). (subMatrix at: 3 at: 1)}  )).
	ret1 > 0 
	ifTrue:[^ret1]
	ifFalse:[ret2> 0
		ifTrue:[^ret2]
		ifFalse:[^0]
		]! !

!UT3AISuper methodsFor: 'Winning Judgements' stamp: 'Oliver 7/16/2013 15:56'!
checkWinningWithRow: subMatrix

	| ret1 ret2 ret3 |
	ret1 := (self checkWinningWithSet: ((subMatrix atRow: 1) asSet)).
	ret2 := (self checkWinningWithSet: ((subMatrix atRow: 2) asSet)).
	ret3 := (self checkWinningWithSet: ((subMatrix atRow: 3) asSet)).
	ret1 > 0 
	ifTrue:[^ret1]
	ifFalse:[ret2> 0
		ifTrue:[^ret2]
		ifFalse:[ret3 > 0
			ifTrue:[^ret3]
			ifFalse:[^0]
			]
		]! !

!UT3AISuper methodsFor: 'Winning Judgements' stamp: 'Oliver 7/16/2013 15:56'!
checkWinningWithSet: aSet

	|  |
	(aSet size = 1)
	ifTrue:["judge"
		(aSet includes: 1)
		ifTrue:[ ^1 ]
		ifFalse:[
			(aSet includes: 2)
				ifTrue:[ ^2 ]
				ifFalse:[ ^0 ].
			]
		]
	ifFalse:[^0]! !

!UT3AISuper methodsFor: 'Winning Judgements' stamp: 'Oliver 7/16/2013 15:56'!
checkWinningWithSubMatrix: subMatrix

	| ret1 ret2 ret3 |
	ret1 := (self checkWinningWithRow: subMatrix).
	ret2 := (self checkWinningWithCol: subMatrix).
	ret3 := (self checkWinningWithDiagonal: subMatrix).
	ret1 > 0 
	ifTrue:[^ret1]
	ifFalse:[ret2> 0
		ifTrue:[^ret2]
		ifFalse:[ret3 > 0
			ifTrue:[^ret3]
			ifFalse:[^0]
			]
		]! !

!UT3AISuper methodsFor: 'initialize-release' stamp: 'Oliver 7/20/2013 15:31'!
initialize 
	
	"in ms for the monte carlo ai bot"
	| nextMove |
	aiThinkingTime := 5000.
	
	corners := { { #1. #1 } .{ #1. #3 } .{ #3. #1 } .{ #3. #3 }  }.

	"2 1 2 
	1 3 1 
	2 1 2"	
	weighting := Matrix new: (board size) element: 0.
	weighting at: 1 at: 1 put: 2.
	weighting at: 1 at: 2 put: 1.
	weighting at: 1 at: 3 put: 2.
	weighting at: 2 at: 1 put: 1.
	weighting at: 2 at: 2 put: 3.
	weighting at: 2 at: 3 put: 1.
	weighting at: 3 at: 1 put: 2.
	weighting at: 3 at: 2 put: 1.
	weighting at: 3 at: 3 put: 2.
	
	scoring := Matrix new: (board size) element: 0.
	
	
	"Refactorred initialize"	
	( (board type) = #basic)
	ifTrue: [
		"basic board"
	privateSet := Set new.
	privateMatrix := Matrix new: (board size) element: 0. 
	
	1 to: board size do: [ :aRow |
		1 to: board size do: [ :aCol |
			nextMove := { aRow. aCol }.
			(board canMoveAt: nextMove readStream)
			ifTrue: [ privateSet add: nextMove ].
			
			(((board at: aRow at: aCol) state) = #circle)
			ifTrue: [ 
				privateMatrix at: aRow at: aCol put: 1 
				]
			ifFalse: [ 
				(((board at: aRow at: aCol) state) = #cross)
				ifTrue: [ privateMatrix at: aRow at: aCol put: 2 ]
				ifFalse: [ privateMatrix at: aRow at: aCol put: 0 ]
				]
			
			 ]
		 ].
	]
	ifFalse: [
		( (board type) = #nested)
		ifTrue: [ "nested board" 
			
			]
		ifFalse: [ "possible further extensions"
			
			 ]
		].
	
	
	privateSet size = 0 ifTrue: [ AIError signal: 'Board is full!!' ].! !

!UT3AISuper methodsFor: 'public' stamp: 'Oliver 7/16/2013 15:57'!
move 
	"Extensive search"
	| nextMove |
	privateSet := Set new.
	privateMatrix := Matrix new: (board size) element: 0. 
	
	1 to: board size do: [ :aRow |
		1 to: board size do: [ :aCol |
			nextMove := { aRow. aCol }.
			(board canMoveAt: nextMove readStream)
			ifTrue: [ privateSet add: nextMove ].
			
			(((board at: aRow at: aCol) state) = #circle)
			ifTrue: [ 
				privateMatrix at: aRow at: aCol put: 1 
				]
			ifFalse: [ 
				(((board at: aRow at: aCol) state) = #cross)
				ifTrue: [ privateMatrix at: aRow at: aCol put: 2 ]
				ifFalse: [ privateMatrix at: aRow at: aCol put: 0 ]
				]
			
			 ]
		 ].
	
	privateSet size = 0 ifTrue: [ AIError signal: 'Board is full!!' ].
	"nextMove := available atRandom."
	nextMove := (self randomthinking).
	
	board at: nextMove put: piece.! !

!UT3AISuper methodsFor: 'thinkings' stamp: 'Oliver 7/16/2013 15:55'!
randomthinking
	"return an integer that represents the number of player pieces in a row"
	| |
	^privateSet atRandom! !

UT3AISuper subclass: #UT3HardAI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3AI'!

!UT3HardAI commentStamp: '<historical>' prior: 0!
An UT3HardAI is a crazy one.

Instance Variables
	privateMatrix:		<Object>
	privateSet:		<Object>
	retMatrix:		<Object>
	retMove:		<Object>

privateMatrix
	- xxxxx

privateSet
	- xxxxx

retMatrix
	- xxxxx

retMove
	- xxxxx
!

!UT3HardAI methodsFor: 'private' stamp: 'Oliver 7/19/2013 17:07'!
IWin
	"return an integer that represents the number of player pieces in a row"

	"gonna win!!"
	| tempMatrix x y |
	retMove := { #2. #2 }.
	retMatrix := Matrix new: (board size) element: 0.
	
	privateSet do: [ :tempCord | 
		x := tempCord first.
		y := tempCord second. 
		tempMatrix := (privateMatrix deepCopy). 
		tempMatrix at: x at: y put: 2. 
		( (self checkWinningWithSubMatrix: tempMatrix) = 2 )
		ifTrue:[ retMatrix at: x at: y put: 2. retMove := { x. y } ]
		ifFalse:[  ]
		 ].
	
	( retMatrix includes: 2 )
	ifTrue:[^true]
	ifFalse:[^false].
! !

!UT3HardAI methodsFor: 'private' stamp: 'Oliver 7/20/2013 15:28'!
initialize 
	|  |
	super initialize.! !

!UT3HardAI methodsFor: 'public' stamp: 'Oliver 7/19/2013 17:02'!
move 
	"Extensive search"
	| nextMove |
	
	self initialize.
	
	"nextMove := available atRandom."
	nextMove := (self thinking).
	
	board at: nextMove put: piece.! !

!UT3HardAI methodsFor: 'private' stamp: 'Oliver 7/19/2013 17:07'!
opponentWin
	"return an integer that represents the number of player pieces in a row"

	"gonna win!!"
	| tempMatrix x y |
	retMove := { #2. #2 }.
	retMatrix := Matrix new: (board size) element: 0.
	
	privateSet do: [ :tempCord | 
		x := tempCord first.
		y := tempCord second. 
		tempMatrix := (privateMatrix deepCopy). 
		tempMatrix at: x at: y put: 1. 
		( (self checkWinningWithSubMatrix: tempMatrix) = 1 )
		ifTrue:[ retMatrix at: x at: y put: 1. retMove := { x. y } ]
		ifFalse:[  ]
		 ].
	
	( retMatrix includes: 1 )
	ifTrue:[^true]
	ifFalse:[^false].
! !

!UT3HardAI methodsFor: 'private' stamp: 'Oliver 7/19/2013 16:52'!
pickCorner
	"return an integer that represents the number of player pieces in a row"

	"gonna win!!"
	| |
	retMove := nil.
	
	corners do: [ :tempCord | 
		(privateSet includes: tempCord)
		ifTrue:[ retMove := tempCord. ^true  ]
		ifFalse:[  ]
		 ].
	
	^false.
! !

!UT3HardAI methodsFor: 'private' stamp: 'Oliver 7/20/2013 04:24'!
thinking 
	"return an integer that represents the number of player pieces in a row"
	|  |
	( (self checkWinningWithSubMatrix: privateMatrix) > 0 )
	ifTrue:[ "self error:'Already win!!'" ].
	
	(self IWin )
	ifTrue: [  
		"tempIndex := retMatrix indexOf: 2 ifAbsent: [ privateSet atRandom  ]."
		^retMove
		].
	
	(self opponentWin )
	ifTrue: [  
		"tempIndex := retMatrix indexOf: 1 ifAbsent: [ privateSet atRandom  ]."
		^retMove
		].
	
	( (privateMatrix at: 2 at: 2) = 0 )
	ifTrue: [ ^{ #2. #2 } ].
	
	(self pickCorner )
	ifTrue: [  
		"tempIndex := retMatrix indexOf: 1 ifAbsent: [ privateSet atRandom  ]."
		^retMove
		].
	
	^privateSet atRandom! !

UT3AISuper subclass: #UT3InsaneAI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3AI'!

!UT3InsaneAI commentStamp: '<historical>' prior: 0!
An UT3InsaneAI is an Extensive one.

Instance Variables
!

!UT3InsaneAI methodsFor: 'private' stamp: 'Oliver 7/20/2013 14:17'!
IWin
	"return an integer that represents the number of player pieces in a row"

	"gonna win!!"
	| tempMatrix x y |
	retMove := { #2. #2 }.
	retMatrix := Matrix new: (board size) element: 0.
	
	privateSet do: [ :tempCord | 
		x := tempCord first.
		y := tempCord second. 
		tempMatrix := (privateMatrix deepCopy). 
		tempMatrix at: x at: y put: 2. 
		( (self checkWinningWithSubMatrix: tempMatrix) = 2 )
		ifTrue:[ 
			retMatrix at: x at: y put: 2. retMove := { x. y }. scoring at: x at: y put: ( (scoring at: x at: y) > 10 ifTrue: [ scoring at: x at: y ]  ifFalse: [10 ] ).
			]
		ifFalse:[  ]
		 ].
	
	( retMatrix includes: 2 )
	ifTrue:[^true]
	ifFalse:[^false].
! !

!UT3InsaneAI methodsFor: 'private' stamp: 'Oliver 7/20/2013 14:33'!
calculating 
	"return an integer that represents the number of player pieces in a row"
	|  |
	(self IWin )
	ifTrue: [  
		"tempIndex := retMatrix indexOf: 2 ifAbsent: [ privateSet atRandom  ]."
		"^retMove"
		].
	retMove := nil.
	
	(self opponentWin )
	ifTrue: [  
		"tempIndex := retMatrix indexOf: 1 ifAbsent: [ privateSet atRandom  ]."
		"^retMove"
		].
	retMove := nil.
! !

!UT3InsaneAI methodsFor: 'private' stamp: 'Oliver 7/20/2013 14:29'!
getBestMove
	
	| max tempScore |
	max := -1.
	
	1 to: (board size) do: [ :tempRow |
		1 to: (board size) do: [ :tempCol |
			tempScore := scoring at: tempRow at: tempCol.
			(max < tempScore ) 
			ifTrue: [ max := tempScore. retMove := { tempRow. tempCol } ]
			ifFalse: [  ]
			 ]
		 ].
	
	(retMove isNil)
	ifTrue: [ ^(self randomthinking) ]
	ifFalse:[ ^retMove ]! !

!UT3InsaneAI methodsFor: 'private' stamp: 'Oliver 7/20/2013 15:31'!
initialize 
	| |
	super initialize.
! !

!UT3InsaneAI methodsFor: 'public' stamp: 'Oliver 7/20/2013 04:27'!
move 
	"Extensive search"
	| nextMove |
	
	self initialize.
	
	"nextMove := available atRandom."
	nextMove := (self thinking).
	
	board at: nextMove put: piece.! !

!UT3InsaneAI methodsFor: 'private' stamp: 'Oliver 7/20/2013 14:18'!
opponentWin
	"return an integer that represents the number of player pieces in a row"

	"gonna win!!"
	| tempMatrix x y |
	retMove := { #2. #2 }.
	retMatrix := Matrix new: (board size) element: 0.
	
	privateSet do: [ :tempCord | 
		x := tempCord first.
		y := tempCord second. 
		tempMatrix := (privateMatrix deepCopy). 
		tempMatrix at: x at: y put: 1. 
		( (self checkWinningWithSubMatrix: tempMatrix) = 1 )
		ifTrue:[ 
			retMatrix at: x at: y put: 1. retMove := { x. y }. scoring at: x at: y put: ( (scoring at: x at: y) > 9 ifTrue: [ scoring at: x at: y ]  ifFalse: [ 9 ] ).
			 ]
		ifFalse:[  ]
		 ].
	
	( retMatrix includes: 1 )
	ifTrue:[^true]
	ifFalse:[^false].
! !

!UT3InsaneAI methodsFor: 'private' stamp: 'Oliver 7/20/2013 04:27'!
pickCorner
	"return an integer that represents the number of player pieces in a row"

	"gonna win!!"
	| |
	retMove := nil.
	
	corners do: [ :tempCord | 
		(privateSet includes: tempCord)
		ifTrue:[ retMove := tempCord. ^true  ]
		ifFalse:[  ]
		 ].
	
	^false.
! !

!UT3InsaneAI methodsFor: 'private' stamp: 'Oliver 7/20/2013 14:39'!
thinking 
	"return an integer that represents the number of player pieces in a row"
	|  x y |
	( (self checkWinningWithSubMatrix: privateMatrix) > 0 )
	ifTrue:[ "self error:'Already win!!'" ].
	
	privateSet do: [ :tempCord | 
		x := tempCord first.
		y := tempCord second. 
		scoring at: x at: y put: (weighting at: x at: y ifInvalid:[self error:'weighting cordinate error, contact admin!!'])
		 ].
	
	self calculating.
	
	^(self getBestMove).
	
	"^privateSet atRandom" ! !

UT3AISuper subclass: #UT3MedAI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3AI'!

!UT3MedAI commentStamp: '<historical>' prior: 0!
An UT3MediumAI is a moderate one.

Instance Variables
!

!UT3MedAI methodsFor: 'private' stamp: 'Oliver 7/19/2013 17:16'!
IWin
	"return an integer that represents the number of player pieces in a row"

	"gonna win!!"
	| tempMatrix x y |
	retMove := { #2. #2 }.
	retMatrix := Matrix new: (board size) element: 0.
	
	privateSet do: [ :tempCord | 
		x := tempCord first.
		y := tempCord second. 
		tempMatrix := (privateMatrix deepCopy). 
		tempMatrix at: x at: y put: 2. 
		( (self checkWinningWithSubMatrix: tempMatrix) = 2 )
		ifTrue:[ retMatrix at: x at: y put: 2. retMove := { x. y } ]
		ifFalse:[  ]
		 ].
	
	( retMatrix includes: 2 )
	ifTrue:[^true]
	ifFalse:[^false].
! !

!UT3MedAI methodsFor: 'private' stamp: 'Oliver 7/19/2013 16:57'!
initialize 
	super initialize.! !

!UT3MedAI methodsFor: 'public' stamp: 'Oliver 7/20/2013 15:35'!
move 
	"Extensive search"
	| nextMove |

	self initialize.
	
	"nextMove := available atRandom."
	nextMove := (self thinking).
	
	board at: nextMove put: piece.! !

!UT3MedAI methodsFor: 'private' stamp: 'Oliver 7/19/2013 17:16'!
opponentWin
	"return an integer that represents the number of player pieces in a row"

	"gonna win!!"
	| tempMatrix x y |
	retMove := { #2. #2 }.
	retMatrix := Matrix new: (board size) element: 0.
	
	privateSet do: [ :tempCord | 
		x := tempCord first.
		y := tempCord second. 
		tempMatrix := (privateMatrix deepCopy). 
		tempMatrix at: x at: y put: 1. 
		( (self checkWinningWithSubMatrix: tempMatrix) = 1 )
		ifTrue:[ retMatrix at: x at: y put: 1. retMove := { x. y } ]
		ifFalse:[  ]
		 ].
	
	( retMatrix includes: 1 )
	ifTrue:[^true]
	ifFalse:[^false].
! !

!UT3MedAI methodsFor: 'private' stamp: 'Oliver 7/20/2013 04:25'!
thinking 
	"return an integer that represents the number of player pieces in a row"
	|  |
	( (self checkWinningWithSubMatrix: privateMatrix) > 0 )
	ifTrue:[ "self error:'Already win!!'" ].
	
	(self IWin )
	ifTrue: [  
		"tempIndex := retMatrix indexOf: 2 ifAbsent: [ privateSet atRandom  ]."
		^retMove
		].
	
	(self opponentWin )
	ifTrue: [  
		"tempIndex := retMatrix indexOf: 1 ifAbsent: [ privateSet atRandom  ]."
		^retMove
		].
	
	( (privateMatrix at: 2 at: 2) = 0 )
	ifTrue: [ ^{ #2. #2 } ].
	
	^privateSet atRandom! !

UT3AI subclass: #UT3EasyAI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3AI'!

!UT3EasyAI commentStamp: '<historical>' prior: 0!
An UT3EasyAI is an AI with a very simple heuristic function.

Instance Variables
!

!UT3EasyAI methodsFor: 'private' stamp: 'JonathanOsting 7/11/2013 15:50'!
heuristic: moveCoords
	"return an integer that represents the number of player pieces in a row"
	| score val myScore oppScore freeScore |
	score := 0.
	(1 to: (board size)) do: [ :i |  	
		" doRows "
		myScore := 0.
		oppScore := 0.	
		freeScore := 0.
		(1 to: (board size)) do: [ :j |  
			(moveCoords first = i & moveCoords second = j) ifTrue: [ myScore := myScore +1 ]
			ifFalse: [ 
				val := board at: i at: j.
				piece = val ifTrue: [ myScore := myScore +1 ]
				ifFalse: [ val isEmpty ifTrue: [ freeScore := freeScore + 1 ]
					ifFalse: [ oppScore := oppScore + 1 ] ] ].
				oppScore = 0 ifTrue: [ score := score + myScore + freeScore ].
				(oppScore > 0 & myScore = 0) ifTrue: [ score := score - oppScore - freeScore ]. ].
		" doCols "
		myScore := 0.
		oppScore := 0.	
		freeScore := 0.
		(1 to: (board size)) do: [ :j |  
			(moveCoords first = j & moveCoords second = i) ifTrue: [ myScore := myScore +1 ]
			ifFalse: [ 
				val := board at: j at: i.
				piece = val ifTrue: [ myScore := myScore +1 ]
							ifFalse: [ val isEmpty ifTrue: [ freeScore := freeScore + 1 ]
												  ifFalse: [ oppScore := oppScore + 1 ] ] ] ].
				oppScore = 0 ifTrue: [ score := score + myScore + freeScore ].
				(oppScore > 0 & myScore = 0) ifTrue: [ score := score - oppScore - freeScore ]. ].
	^ score! !

!UT3EasyAI methodsFor: 'public' stamp: 'Oliver 7/16/2013 15:25'!
move 
	"TODO(josting2): Describe algorithm."
	|available nextMove|
	available := SortedCollection sortBlock: [ :val1 :val2 | (self heuristic: val1) > (self heuristic: val2). ].
	1 to: board size do: [ :aRow |
		1 to: board size do: [ :aColumn |
			nextMove := { aRow. aColumn }.
			(board canMoveAt: nextMove readStream)
			ifTrue: [ available add: nextMove ]
			 ]
		 ].
	available size = 0 ifTrue: [ AIError signal: 'Board is full!!' ].
	nextMove := available first.
	board at: nextMove put: piece.! !

UT3AI subclass: #UT3NestedRandomAI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3AI'!

!UT3NestedRandomAI commentStamp: '<historical>' prior: 0!
An UT3NestedRandomAI is yet another dumb AI, but works on the nested board.

Instance Variables
!

!UT3NestedRandomAI methodsFor: 'public' stamp: 'Oliver 7/20/2013 15:15'!
move
	|size available nextMove|
	size := board size.
	available := Set new.
	1 to: size do: [ :row |
		1 to: size do: [ :column |
			1 to: size do: [ :subRow |
				1 to: size do: [ :subColumn |
					( board canMoveAt: { row. column. subRow . subColumn } readStream)
					ifTrue: [ available add: { row. column. subRow. subColumn } ]
					]
				 ]
			 ]
		 ].
	nextMove := available atRandom.
	board at: nextMove put: piece! !

UT3AI subclass: #UT3RandomAI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3AI'!

!UT3RandomAI commentStamp: '<historical>' prior: 0!
An UT3RandomAI is a dumb AI, that just makes a random move on any moveable space.

Instance Variables
!

!UT3RandomAI methodsFor: 'public' stamp: 'JonathanOsting 7/8/2013 16:40'!
move 
	"Dumb logic here. Just find coordinates that can be moved to, then move there."
	|available nextMove|
	available := Set new.
	1 to: board size do: [ :aRow |
		1 to: board size do: [ :aColumn |
			nextMove := { aRow. aColumn }.
			(board canMoveAt: nextMove readStream)
			ifTrue: [ available add: nextMove ]
			 ]
		 ].
	available size = 0 ifTrue: [ AIError signal: 'Board is full!!' ].
	nextMove := available atRandom.
	board at: nextMove put: piece.! !
